library soliq_id;

import 'package:camera/camera.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:soliq_id/src/data/bloc/soliq_id_bloc.dart';
import 'package:soliq_id/src/data/storages/preference.dart';

import 'src/data/di/di_container.dart';
import 'src/data/repository/soliq_id_repository.dart';
import 'src/screens/face_id_signin.dart';

import 'localizations_util.dart';

List<CameraDescription> cameras = [];
Preference? pref;

class SoliqId extends StatefulWidget {
  const SoliqId({
    Key? key,
    required this.pinfl,
    required this.localizationType,
    required this.guid,
  }) : super(key: key);
  final pinfl;
  final LocalizationType localizationType;
  final String guid;

  @override
  State<SoliqId> createState() => _SoliqIdState();
}

class _SoliqIdState extends State<SoliqId> {
  // todo - add preference to singleton
   Preference preference = Preference();

  @override
  void initState()  {
    super.initState();



    getGuid();

  }

  @override
  Widget build(BuildContext context) {

    return BlocProvider(
      create: (context) => SoliqIdBloc(
        getIt<SoliqIdRepository>(),
      ),
      child: FaceIdSignIn(
        pinfl: widget.pinfl,
        localizationType: widget.localizationType,
        guid: widget.guid,
      ),
    );
  }

  Future<void> getGuid() async {
    final locale = getLocalizationType(
      widget.localizationType,
    );
    final preference = Preference();
    await preference.setLang(locale);
    await preference.setGUID(widget.guid);
    cameras = await availableCameras();
    await initDi();
    pref = await preference.init();
    await Future.delayed(const Duration(seconds: 2));
  }

  @override
  void dispose() async {
     await preference.removeGUID();
    super.dispose();
  }
}
